(************************************************************
Author: Deepak Shenoy
        shenoy@agnisoft.com
Copyright (C) 2000 Agni Software Pvt. Ltd.
All Rights Reserved.
http://www.agnisoft.com

Description:
Core Object for all IADS implementations. Returns the class name,
schema name etc.
********************************************************)
unit AdsCore;

interface
uses
  ComObj, ActiveX, BDEProv_TLB, StdVcl,ActiveDS_TLB, Windows;

type
  TAdsAutoObject = class(TAutoObject, IADs)
  protected
    _Name     : WideString;
    _Adspath  : WideString;
    _Parent   : WideString;
    _AdsClass : WideString;
    _AdsGuid  : WideString;
    _Schema   : WideString;
  public
        {IADs}
    function  Get_Name: WideString; safecall;
    function  Get_Class_: WideString; safecall;
    function  Get_GUID: WideString; safecall;
    function  Get_ADsPath: WideString; safecall;
    function  Get_Parent: WideString; safecall;
    function  Get_Schema: WideString; safecall;
    procedure GetInfo; safecall;
    procedure SetInfo; safecall;
    function  Get(const bstrName: WideString): OleVariant; virtual; safecall; 
    procedure Put(const bstrName: WideString; vProp: OleVariant); virtual; safecall; 
    function  GetEx(const bstrName: WideString): OleVariant; safecall;
    procedure PutEx(lnControlCode: Integer; const bstrName: WideString; vProp: OleVariant); safecall;
    procedure GetInfoEx(vProperties: OleVariant; lnReserved: Integer); safecall;

    procedure NotImpl;
  end;
implementation

{ TAdsAutoObject }

function TAdsAutoObject.Get(const bstrName: WideString): OleVariant;
begin
end;

function TAdsAutoObject.Get_ADsPath: WideString;
begin

end;

function TAdsAutoObject.Get_Class_: WideString;
begin

end;

function TAdsAutoObject.Get_GUID: WideString;
begin

end;

function TAdsAutoObject.Get_Name: WideString;
begin
  Result := _Name;
end;

function TAdsAutoObject.Get_Parent: WideString;
begin
  Result := _Parent;
end;

function TAdsAutoObject.Get_Schema: WideString;
begin
  Result := _Schema;
end;

function TAdsAutoObject.GetEx(const bstrName: WideString): OleVariant;
begin
  raise EOleSysError.Create('Not Impl', E_NOTIMPL, 0);
end;

procedure TAdsAutoObject.GetInfo;
begin
  raise EOleSysError.Create('Not Impl', E_NOTIMPL, 0);
end;

procedure TAdsAutoObject.GetInfoEx(vProperties: OleVariant;
  lnReserved: Integer);
begin
  raise EOleSysError.Create('Not Impl', E_NOTIMPL, 0);
end;

procedure TAdsAutoObject.Put(const bstrName: WideString;
  vProp: OleVariant);
begin
  raise EOleSysError.Create('Not Impl', E_NOTIMPL, 0);
end;

procedure TAdsAutoObject.PutEx(lnControlCode: Integer;
  const bstrName: WideString; vProp: OleVariant);
begin
  raise EOleSysError.Create('Not Impl', E_NOTIMPL, 0);
end;

procedure TAdsAutoObject.SetInfo;
begin
  raise EOleSysError.Create('Not Impl', E_NOTIMPL, 0);
end;

procedure TAdsAutoObject.NotImpl;
begin
  raise EOleSysError.Create('Not Impl', E_NOTIMPL, 0);
end;

end.
