(************************************************************
Author: Deepak Shenoy
        shenoy@agnisoft.com
Copyright (C) 2000 Agni Software Pvt. Ltd.
All Rights Reserved.
http://www.agnisoft.com

Description:
Enumerator unit that implements IEnumVariant.
Takes the BDE Alias and enumerates them
********************************************************)
unit EnumNS;

interface
uses
  ComObj, ActiveX, BDEProv_TLB, classes, Windows, GenObject;

type
  TEnumBDENamespace = class (TInterfacedObject, IEnumVARIANT)
  protected
    FAliases : TStringList;
    FCurNo : integer;
    function Next(celt: LongWord; var rgvar : OleVariant;
      out pceltFetched: LongWord): HResult; stdcall;
    function Skip(celt: LongWord): HResult; stdcall;
    function Reset: HResult; stdcall;
    function Clone(out Enum: IEnumVariant): HResult; stdcall;
  public
    constructor Create( List : TStrings ); 
    destructor Destroy; override;
  end;

implementation

{ TEnumBDENamespace }

function TEnumBDENamespace.Clone(out Enum: IEnumVariant): HResult;
begin
   raise EOleSysError.Create('Not Impl', E_NOTIMPL, 0);
end;

constructor TEnumBDENamespace.Create(List: TStrings);
begin
  FCurNo := 0;
  FAliases := TStringList.Create;
  FAliases.Assign(List );
end;

destructor TEnumBDENamespace.Destroy;
begin
  inherited;
  FAliases.Free;
end;

function TEnumBDENamespace.Next(celt: LongWord; var rgvar: OleVariant;
  out pceltFetched: LongWord): HResult;
var aVarData : array of Variant;
    i, iElement, iFetched : integer;
    obj : TBDEGenObject;
begin
  if FCurNo >= FAliases.Count then
  begin
    Result := S_FALSE;
    Exit;
  end;
  if @pceltFetched <> nil then
    pceltFetched := 0;
  iFetched := 0;
  iElement := FCurNo;

  if celt > 1 then
  begin
    if not VarIsArray(rgVar) then
        rgVar := VarArrayCreate([0,celt-1],varVariant);

    SetLength(aVarData, celt);

    while (iFetched < celt) and (iElement < FAliases.Count) do
    begin
      obj := TBDEGenObject.Create;
      obj.Alias := FAliases[iElement];
      aVarData[iFetched] := IDispatch(obj);
      inc(iFetched);
      inc(iElement);
    end;

    FCurNO := iElement;
    VarCopy(rgVar, aVarData);
  end
  else
  begin
    obj := TBDEGenObject.Create;
    obj.Alias := FAliases[FCurNo];
    rgVar := IDispatch(obj);
    Inc(FCurNo, 1);
  end;
end;

function TEnumBDENamespace.Reset: HResult;
begin
   raise EOleSysError.Create('Not Impl', E_NOTIMPL, 0);
end;

function TEnumBDENamespace.Skip(celt: LongWord): HResult;
begin
  raise EOleSysError.Create('Not Impl', E_NOTIMPL, 0);
end;

end.
